//获取手机屏幕大小信息
var sw = 0
var sh = 0
//是否为iPhoneX
let isiPhoneX = false
wx.getSystemInfo({
  success: function (res) {
    sw = res.screenWidth
    sh = res.screenHeight
    let mobileType = res.model
    if (mobileType == 'iPhone X') isiPhoneX = true
    else isiPhoneX = false
  }
})
const screenWidth = sw
const screenHeight = sh

/*
画两边的灰色选择栏和下一页按钮
*/
function basePage(context) {
  if (isiPhoneX) {
    context.fillStyle = '#fff'
    context.fillRect(35 * 2, 0, screenWidth * 2, screenHeight * 2)
    context.fillStyle = '#f8f8f8'
    context.fillRect(35 * 2, 0, screenWidth * 2, 40 * 2)
    context.fillRect(35 * 2, 50 * 2, 40 * 2, screenHeight * 2)
    context.fillRect((screenWidth - 50) * 2, 50 * 2, 50 * 2, screenHeight * 2)
    context.fillStyle = '#FFA500'
    context.fillRect((screenWidth - 50) * 2, (screenHeight - 30) * 2, 50 * 2, 30 * 2)
    context.fillRect((screenWidth - 50) * 2, (screenHeight - 65) * 2, 50 * 2, 30 * 2)
    context.font = '20px Arial'
    context.fillStyle = '#696969'
    context.fillText('新品上市', 35 * 2, 70 * 2)
    context.fillText('促销产品', 35 * 2, 95 * 2)
    context.fillText('风格', 35 * 2, 120 * 2)
  } else {
    context.fillStyle = '#fff'
    context.fillRect(0, 0, screenWidth * 2, screenHeight * 2)
    context.fillStyle = '#f8f8f8'
    context.fillRect(0, 0, screenWidth * 2, 40 * 2)
    context.fillRect(0, 50 * 2, 40 * 2, screenHeight * 2)
    context.fillRect((screenWidth - 50) * 2, 50 * 2, 50 * 2, screenHeight * 2)
    context.fillStyle = '#FFA500'
    context.fillRect((screenWidth - 50) * 2, (screenHeight - 30) * 2, 50 * 2, 30 * 2)
    context.fillRect((screenWidth - 50) * 2, (screenHeight - 65) * 2, 50 * 2, 30 * 2)
    context.font = '20px Arial'
    context.fillStyle = '#696969'
    context.fillText('新品上市', 0, 70 * 2)
    context.fillText('促销产品', 0, 95 * 2)
    context.fillText('风格', 0, 120 * 2)
  }
  context.fillStyle = '#FFA500'
  context.fillRect(300, 20, 100, 40)
  context.fillStyle = '#fff'
  context.font = "26px Arial"
  context.fillText('下一页', (screenWidth - 46) * 2, (screenHeight - 9) * 2)
  context.fillText('上一页', (screenWidth - 46) * 2, (screenHeight - 44) * 2)
  context.font = "26px Arial"
  context.fillText('搜索', 320, 50)
  context.fillRect(76,20,220,40)
  context.fillStyle = '#696969'
  context.fillText('关键词查询',90,50)

}
export { basePage }
