//获取手机屏幕大小信息
var sw = 0
var sh = 0
//是否为iPhoneX
let isiPhoneX = false
wx.getSystemInfo({
  success: function (res) {
    sw = res.screenWidth
    sh = res.screenHeight
    let mobileType = res.model
    if (mobileType == 'iPhone X') isiPhoneX = true
    else isiPhoneX = false
  }
})
const screenWidth = sw
const screenHeight = sh
//功能栏
let img1 = wx.createImage()
img1.src = 'images/1.png'
let img2 = wx.createImage()
img2.src = 'images/3.png'
let img3 = wx.createImage()
img3.src = 'images/4.png'
let img4 = wx.createImage()
img4.src = 'images/2.png'
let img5 = wx.createImage()
img5.src = 'images/5.png'
let forward = wx.createImage()
forward.src = 'images/forward.png'
let back = wx.createImage()
back.src = 'images/back.png'
let ratio = img1.width / img1.height
let loadingDown = false
export default class Details {
  showDetails(context, image, text, price) {
    if (isiPhoneX) {
      //加载大图
      image.onload = function () {        
        context.clearRect(0, 0, screenWidth * 2, screenHeight * 2)
        context.drawImage(image, 70, 0, screenWidth * 2, screenHeight * 2)
        context.drawImage(img1, (screenWidth / 2 - 200) * 2 + 70, (screenHeight - 35) * 2, 90 * 2, (90 / ratio) * 2)
        context.drawImage(img2, (screenWidth / 2 - 100) * 2 + 70, (screenHeight - 35) * 2, 90 * 2, (90 / ratio) * 2)
        context.drawImage(img3, (screenWidth / 2) * 2 + 70, (screenHeight - 35) * 2, 90 * 2, (90 / ratio) * 2)
        context.drawImage(img4, (screenWidth / 2 + 100) * 2 + 70, (screenHeight - 35) * 2, 90 * 2, (90 / ratio) * 2)
        context.drawImage(img5, 10 * 2 + 70, (screenHeight - 40) * 2, 30 * 2, 30 * 2)
        context.drawImage(forward, (screenWidth - 40) * 2, (screenHeight / 2 - 15) * 2, 60, 60)
        context.drawImage(back, 10 * 2 + 70, (screenHeight / 2 - 15) * 2, 60, 60)
        //编号和单价
        context.fillStyle = 'rgba(0,0,0,0.25)'
        context.fillRect(70, 0, screenWidth*2 - 70, 60)
        context.font = "32px Arial"
        context.fillStyle = '#fff'
        context.fillText(text, 80 * 2, 25 * 2)
        if(price != ''){
          context.fillText('单价：', screenWidth, 25 * 2)
          context.fillStyle = '#FFA500'
          context.fillText('¥' + price, screenWidth + 90, 25 * 2)
        }  
        wx.hideLoading()  
      }
    } else {
      //加载大图
      image.onload = function () {
        context.clearRect(0, 0, screenWidth * 2, screenHeight * 2)
        context.drawImage(image, 0, 0, screenWidth * 2, screenHeight * 2)
        //编号和单价
        context.fillStyle = 'rgba(0,0,0,0.25)'
        context.fillRect(0,0,screenWidth*2,60)
        context.font = "32px Arial"
        context.fillStyle = '#fff'
        context.fillText(text, 80 * 2, 25 * 2)
        if(price != ''){
          context.fillText('单价：', screenWidth, 25 * 2)
          context.fillStyle = '#FFA500'
          context.fillText('¥' + price, screenWidth + 90, 25 * 2)
        }
        context.drawImage(img1, (screenWidth / 2 - 200) * 2, (screenHeight - 35) * 2, 90 * 2, (90 / ratio) * 2)
        context.drawImage(img2, (screenWidth / 2 - 100) * 2, (screenHeight - 35) * 2, 90 * 2, (90 / ratio) * 2)
        context.drawImage(img3, (screenWidth / 2) * 2, (screenHeight - 35) * 2, 90 * 2, (90 / ratio) * 2)
        context.drawImage(img4, (screenWidth / 2 + 100) * 2, (screenHeight - 35) * 2, 90 * 2, (90 / ratio) * 2)
        context.drawImage(img5, 10 * 2, (screenHeight - 40) * 2, 30 * 2, 30 * 2)
        context.drawImage(forward, (screenWidth - 40) * 2, (screenHeight / 2 - 15) * 2, 60, 60)
        context.drawImage(back, 10 * 2, (screenHeight / 2 - 15) * 2, 60, 60)
        wx.hideLoading()  
      }
    }
  }
}

