import { basePage } from './draw/base.js'
import FLD from './draw/FirstLevelDirectory.js'
import SLD from './draw/SecondLevelDirectory.js'
import Content from './draw/content.js'
import Details from './draw/details.js'

//import canvas from './libs/weapp-adapter.js'

var url = 'https://t6.9026.com/api/album/cat?parent_id=0&store_id=1'//初始顶级目录url
var FLDsource = []//顶级目录对象列表
var SLDsource = []//二级目录对象列表
var GoodsSource = []//商品对象列表
var AllSource = []//所有商品对象
var GoodsDetail//商品详情
var flag1 = 0//通过flag1来判断现在处于哪一个顶级目录，然后利用flag1传参数获取该顶级目录下的二级目录信息
var flag2 = 0//通过flag1来判断现在处于哪一个二级目录，然后利用flag2传参数获取该顶级目录下的商品列表
var flag3 = 0//通过flag3来判断选择的是哪一个商品，然后获取它的的详情
//获取手机屏幕大小信息
var sw = 0
var sh = 0
//是否为iPhoneX
let isiPhoneX = false
wx.getSystemInfo({
  success: function (res) {
    sw = res.screenWidth
    sh = res.screenHeight
    let mobileType = res.model
    if (mobileType == 'iPhone X') isiPhoneX = true
    else isiPhoneX = false
  }
})
console.log('iphonex:' + isiPhoneX)
const screenWidth = sw
const screenHeight = sh
//定义画布
//let canvas = wx.createCanvas()
canvas.height = screenHeight * 2
canvas.width = screenWidth * 2
let context = canvas.getContext('2d')

//中间商品列表显示区绘制辅助变量
var imgx = 0
var imgy = 0
if (isiPhoneX) {
  imgx = (screenWidth - 240 - 35) / 3
  imgy = (screenHeight - 118) / 3
} else {
  imgx = (screenWidth - 180) / 3
  imgy = (screenHeight - 118) / 3
}
const imgX = imgx
const imgY = imgy

//定义按钮区域
//一级目录按钮区域
let FLDbtnArea = []
//二级目录按钮区域
let SLDbtnArea = []

if (isiPhoneX) {
  //产品列表区域
  var CA = [{ startX: 67 + 75, startY: 42, endX: 67 + imgX + 75, endY: 42 + imgY + 25, status: false }, { startX: 77 + 75 + imgX, startY: 42, endX: 77 + 75 + imgX + imgX, endY: 42 + imgY + 25, status: false }, { startX: 87 + 75 + imgX + imgX, startY: 42, endX: 87 + 75 + imgX + imgX + imgX, endY: 42 + 25 + imgY, status: false },
  { startX: 67 + 75, startY: 42 + imgY + 25, endX: 67 + imgX + 75, endY: 42 + imgY + 25 + imgY + 25, status: false }, { startX: 77 + 75 + imgX, startY: 42 + imgY + 25, endX: 77 + 75 + imgX + imgX, endY: 42 + imgY + 25 + imgY + 25, status: false }, { startX: 87 + 75 + imgX + imgX, startY: 42 + imgY + 25, endX: 87 + 75 + imgX + imgX + imgX, endY: 42 + imgY + 25 + imgY + 25, status: false },
  { startX: 67 + 75, startY: 42 + imgY + 25 + imgY + 25, endX: 67 + 75 + imgX, endY: 42 + imgY + 25 + imgY + 25 + imgY + 25, status: false }, { startX: 77 + 75 + imgX, startY: 42 + imgY + 25 + imgY + 25, endX: 77 + 75 + imgX + imgX, endY: 42 + imgY + 25 + imgY + 25 + imgY + 25, status: false }, { startX: 87 + 75 + imgX + imgX, startY: 42 + imgY + 25 + imgY + 25, endX: 87 + 75 + imgX + imgX + imgX, endY: 42 + imgY + 25 + imgY + 25 + imgY + 25, status: false }]
  //详情界面按钮区域
  var DA = [{ startX: 35, startY: screenHeight - 50, endX: 50 + 35, endY: screenHeight }, { startX: screenWidth / 2 - 200 + 35, startY: screenHeight - 35, endX: screenWidth / 2 - 110 + 35, endY: screenHeight - 12 }, { startX: screenWidth / 2 - 100 + 35, startY: screenHeight - 35, endX: screenWidth / 2 - 10 + 35, endY: screenHeight - 12 }, { startX: screenWidth / 2 + 35, startY: screenHeight - 35, endX: screenWidth / 2 + 90 + 35, endY: screenHeight - 12 }, { startX: screenWidth / 2 + 100 + 35, startY: screenHeight - 35, endX: screenWidth / 2 + 190 + 35, endY: screenHeight - 12 }, { startX: 10 + 35, startY: screenHeight / 2 - 15, endX: 40 + 35, endY: screenHeight / 2 + 15 }, { startX: screenWidth - 40, startY: screenHeight / 2 - 15, endX: screenWidth - 10, endY: screenHeight / 2 + 15 }]
  //新品上市，促销产品，风格
  var SA = [{ startX: 35, startY: 50, endX: 60, endY: 75, status: true }, { startX: 35, startY: 75, endX: 60, endY: 100, status: false }, { startX: 35, startY: 100, endX: 60, endY: 125, status: false }]
} else {
  //产品列表区域
  var CA = [{ startX: 67, startY: 42, endX: 67 + imgX, endY: 42 + imgY + 25, status: false }, { startX: 77 + imgX, startY: 42, endX: 77 + imgX + imgX, endY: 42 + imgY + 25, status: false }, { startX: 87 + imgX + imgX, startY: 42, endX: 87 + imgX + imgX + imgX, endY: 42 + 25 + imgY, status: false },
  { startX: 67, startY: 42 + imgY + 25, endX: 67 + imgX, endY: 42 + imgY + 25 + imgY + 25, status: false }, { startX: 77 + imgX, startY: 42 + imgY + 25, endX: 77 + imgX + imgX, endY: 42 + imgY + 25 + imgY + 25, status: false }, { startX: 87 + imgX + imgX, startY: 42 + imgY + 25, endX: 87 + imgX + imgX + imgX, endY: 42 + imgY + 25 + imgY + 25, status: false },
  { startX: 67, startY: 42 + imgY + 25 + imgY + 25, endX: 67 + imgX, endY: 42 + imgY + 25 + imgY + 25 + imgY + 25, status: false }, { startX: 77 + imgX, startY: 42 + imgY + 25 + imgY + 25, endX: 77 + imgX + imgX, endY: 42 + imgY + 25 + imgY + 25 + imgY + 25, status: false }, { startX: 87 + imgX + imgX, startY: 42 + imgY + 25 + imgY + 25, endX: 87 + imgX + imgX + imgX, endY: 42 + imgY + 25 + imgY + 25 + imgY + 25, status: false }]
  //详情界面按钮区域
  var DA = [{ startX: 0, startY: screenHeight - 50, endX: 50, endY: screenHeight }, { startX: screenWidth / 2 - 200, startY: screenHeight - 35, endX: screenWidth / 2 - 110, endY: screenHeight - 12 }, { startX: screenWidth / 2 - 100, startY: screenHeight - 35, endX: screenWidth / 2 - 10, endY: screenHeight - 12 }, { startX: screenWidth / 2, startY: screenHeight - 35, endX: screenWidth / 2 + 90, endY: screenHeight - 12 }, { startX: screenWidth / 2 + 100, startY: screenHeight - 35, endX: screenWidth / 2 + 190, endY: screenHeight - 12 }, { startX: 10, startY: screenHeight / 2 - 15, endX: 40, endY: screenHeight / 2 + 15 }, { startX: screenWidth - 40, startY: screenHeight / 2 - 15, endX: screenWidth - 10, endY: screenHeight / 2 + 15 }]
  //新品上市，促销产品，风格
  var SA = [{ startX: 0, startY: 50, endX: 25, endY: 75, status: true }, { startX: 0, startY: 75, endX: 25, endY: 100, status: false }, { startX: 0, startY: 100, endX: 25, endY: 125, status: false }]
}

const ContentbtnArea = [...CA]
const DetailbtnArea = [...DA]
const SLDArea = [...SA]

//搜索按钮
let SearchButton = [{ startX: 38, startY: 10, endX: 140, endY: 30 }, { startX: 150, startY: 10, endX: 200, endY: 30 }]
//翻页按钮
const pageArea = [{ startX: screenWidth - 50, startY: screenHeight - 30, endX: screenWidth, endY: screenHeight }, { startX: screenWidth - 50, startY: screenHeight - 65, endX: screenWidth, endY: screenHeight - 35 }]
//尺寸安装图片转换界面
const attrArea = [{ startX: (screenWidth - (screenHeight - 100) * 1.778) / 2, startY: 30, endX: screenWidth / 2, endY: 60 }, { startX: screenWidth / 2, startY: 30, endX: (screenWidth + (screenHeight - 100) * 1.778) / 2 - 30, endY: 60 }, { startX: (screenWidth + (screenHeight - 100) * 1.778) / 2 - 30, startY: 30, endX: (screenWidth + (screenHeight - 100) * 1.778) / 2, endY: 60 }]

//定义目录选中状态
let FLDstatus = false
let SLDstatus = false
//定义是否在详情界面状态
let Detailstatus = false
//是否隐藏了按钮
let Buttonstatus = false
//touchmove是否结束
let touchend = false
//是不是经销商
let isAgent = false
//是否到尺寸和安装图片转换界面
let attrFlag = false
//风格是否打开
let styleOpen = true
//当前是尺寸还是安装
let attrORupload = true
//定义当前页数
let page = 0
//手指开始点击的坐标，用于判断手势滑动的左右上下方向
let startx = 0
let starty = 0
//agent_id
let agent_id = 0
let status = 0
let style = 0
let cat_id = 0
//输入的搜索内容
var KeyWord = ''
//厂家名字
var FactoryName = ''
//绘制函数
function reStart() {
  console.log('reStartSuccess')//调用成功输出'reStartSuccess'
  //reset()//清空之前屏幕上的绘制内容，减少缓存占用，及信息重叠
  if (Detailstatus == false) {
    //绘制两个侧边栏
    basePage(context)
    //console.log(parseInt(GoodsSource.length / 9))
    //上一页下一页按钮禁用
    if (parseInt((GoodsSource.length - 1) / 9) == 0 || page == parseInt(GoodsSource.length / 9)) {
      context.fillStyle = '#D3D3D3'
      context.fillRect((screenWidth - 50) * 2, (screenHeight - 30) * 2, 50 * 2, 30 * 2)
      context.fillStyle = '#fff'
      context.font = "26px Arial"
      context.fillText('下一页', (screenWidth - 46) * 2, (screenHeight - 9) * 2)
    }
    if (page == 0) {
      context.fillStyle = '#D3D3D3'
      context.fillRect((screenWidth - 50) * 2, (screenHeight - 65) * 2, 50 * 2, 30 * 2)
      context.fillStyle = '#fff'
      context.font = "26px Arial"
      context.fillText('上一页', (screenWidth - 46) * 2, (screenHeight - 44) * 2)
    }
    //厂家名字
    context.fillStyle = '#000'
    context.font = '30px 黑体'
    context.fillText(FactoryName, screenWidth - 60, 52)
    //绘制一级目录
    try {
      let dir1 = new FLD()
      for (let i = 0; i < FLDsource.length; i++) {
        let img = wx.createImage()
        img.src = FLDsource[i].pic_url
        dir1.drawFLD(context, img, FLDbtnArea[i].status, i, FLDsource[i].name)
      }
    } catch (e) {
      console.log(e.message)
    }
    //绘制二级目录
    try {
      if (SLDArea[0].status == true) {
        context.fillStyle = '#f8f8f8'
        context.fillRect(SLDArea[0].startX * 2, SLDArea[0].startY * 2, 40 * 2, 25 * 2)
        context.font = '20px Arial'
        context.fillStyle = '#FFA500'
        context.fillText('新品上市', SLDArea[0].startX * 2, (SLDArea[0].startY + 20) * 2)
        context.fillStyle = '#696969'
        context.fillText('促销产品', SLDArea[1].startX * 2, (SLDArea[1].startY + 20) * 2)
        context.fillText('风格', SLDArea[2].startX * 2, (SLDArea[2].startY + 20) * 2)
      }
      if (SLDArea[1].status == true) {
        context.fillStyle = '#f8f8f8'
        context.fillRect(SLDArea[1].startX * 2, SLDArea[1].startY * 2, 40 * 2, 25 * 2)
        context.font = '20px Arial'
        context.fillStyle = '#FFA500'
        context.fillText('促销产品', SLDArea[1].startX * 2, (SLDArea[1].startY + 20) * 2)
        context.fillStyle = '#696969'
        context.fillText('新品上市', SLDArea[0].startX * 2, (SLDArea[0].startY + 20) * 2)
        context.fillText('风格', SLDArea[2].startX * 2, (SLDArea[2].startY + 20) * 2)
      }
      if (SLDArea[2].status == true) {
        context.fillStyle = '#f8f8f8'
        context.fillRect(SLDArea[2].startX * 2, SLDArea[2].startY * 2, 40 * 2, 25 * 2)
        context.font = '20px Arial'
        context.fillStyle = '#FFA500'
        context.fillText('风格', SLDArea[2].startX * 2, (SLDArea[2].startY + 20) * 2)
        context.fillStyle = '#696969'
        context.fillText('新品上市', SLDArea[0].startX * 2, (SLDArea[0].startY + 20) * 2)
        context.fillText('促销产品', SLDArea[1].startX * 2, (SLDArea[1].startY + 20) * 2)
      } else {
        for (let i in SLDbtnArea) {
          SLDbtnArea[i].status = false
        }
      }
      if (styleOpen == true) {
        let openImg = wx.createImage()
        openImg.src = 'images/7.png'
        openImg.onload = function () {
          context.drawImage(openImg, SLDArea[2].startX * 2 + 25, SLDArea[2].startY * 2 - 5, 40 * 2, 40 * 2)
          let dir2 = new SLD()
          for (let i = 0; i < SLDbtnArea.length; i++) {
            dir2.drawSLD(context, SLDbtnArea[i].status, i, SLDsource[i].name)
          }
        }
      }
      else {
        let openImg = wx.createImage()
        openImg.src = 'images/6.png'
        openImg.onload = function () {
          context.drawImage(openImg, SLDArea[2].startX * 2 + 25, SLDArea[2].startY * 2 - 5, 40 * 2, 40 * 2)
        }
      }
    } catch (e) {
      console.log(e.message)
    }
    //绘制内容
    try {
      let dir3 = new Content()
      if (GoodsSource.length < 10) {//当商品列表小于10的时候，无需翻页，直接绘制
        for (let i = 0; i < GoodsSource.length; i++) {
          let img = wx.createImage()
          img.src = GoodsSource[i].cover_pic
          dir3.drawContent(context, img, i, GoodsSource[i].name)
        }
      }
      else {//当商品列表大于9的时候，需要翻页，通过变量page来控制绘制
        for (let j = page * 9; j < (page + 1) * 9; j++) {
          let img = wx.createImage()
          try {
            img.src = GoodsSource[j].cover_pic
            dir3.drawContent(context, img, j % 9, GoodsSource[j].name)
          } catch (e) {
            console.log(e.message)
          }
        }
        // if (page > (GoodsSource.length - 1) % 9) break //如果页数大于实际页数的话，停止绘制,避免出现获取不到资源而报错
      }
    } catch (e) {
      console.log(e.message)
    }
  } else {//绘制详细内容
    try {
      let dt = new Details()
      //console.log('进入详情')
      let img = new Image()
      img.src = GoodsDetail.detail_pic
      if (Buttonstatus == false) {
        dt.showDetails(context, img, GoodsDetail.name, GoodsDetail.price)
      }
      else {
        if (isiPhoneX) {
          context.drawImage(img, 70, 0, screenWidth * 2, screenHeight * 2)
        } else {
          context.drawImage(img, 0, 0, screenWidth * 2, screenHeight * 2)
        }
      }

    } catch (e) {
      console.log(e.message)
      Detailstatus = false
      wx.showToast({
        title: '暂无详情',
        icon: 'none'
      })
      reStart()
    }
  }
}
//触摸响应函数
wx.onTouchStart(((e) => {
  try {
    //e.preventDefault()
    var x = e.touches[0].clientX
    var y = e.touches[0].clientY
    startx = x
    starty = y
  } catch (evt) {
    console.log(evt.message)
  }
  if (Detailstatus == false) {//当不在详情界面时
    //一级目录控制
    for (let btn in FLDbtnArea) {
      if (x >= FLDbtnArea[btn].startX
        && x <= FLDbtnArea[btn].endX
        && y >= FLDbtnArea[btn].startY
        && y <= FLDbtnArea[btn].endY) {
        for (let i in FLDbtnArea) {//点击该按钮的时候，它变为活跃状态status=true，而其他所有按钮变为非活跃状态status=false
          FLDbtnArea[i].status = false
        }
        for (let i in ContentbtnArea) {//发生页面切换时所有商品详情均为不活跃状态
          ContentbtnArea[i].status = false
        }
        page = 0//发生页面切换时页数置0
        flag1 = btn
        flag2 = 0//发生一级目录切换时，二级目录选中第一个
        status = 2
        //FLDbtnArea[btn].status = true
        SLDArea[0].status = true
        SLDArea[1].status = false
        SLDArea[2].status = false
        getFLDsource(callback1, url)//重绘
      }
    }
    //二级目录控制
    for (let btn in SLDbtnArea) {
      if (x >= SLDbtnArea[btn].startX
        && x <= SLDbtnArea[btn].endX
        && y >= SLDbtnArea[btn].startY
        && y <= SLDbtnArea[btn].endY) {
        if (styleOpen == true) {
          for (let i in SLDbtnArea) {//点击该按钮的时候，它变为活跃状态status=true，而其他所有按钮变为非活跃状态status=false
            SLDbtnArea[i].status = false
          }
          for (let i in ContentbtnArea) {//发生页面切换时所有商品详情均为不活跃状态
            ContentbtnArea[i].status = false
          }
          SLDbtnArea[btn].status = true
          status = 3
          page = 0//发生页面切换时页数置0
          flag2 = btn
          SLDArea[0].status = false
          SLDArea[1].status = false
          SLDArea[2].status = true
          //SLDbtnArea[btn].status = true
          getSLDsource(callback2, FLDsource)//重绘
        }
      }
    }
    if (x >= SLDArea[0].startX
      && x <= SLDArea[0].endX
      && y >= SLDArea[0].startY
      && y <= SLDArea[0].endY) {
      page = 0
      flag2 = 0
      status = 2
      SLDArea[0].status = true
      SLDArea[1].status = false
      SLDArea[2].status = false
      for (let i in SLDbtnArea) {//点击该按钮的时候，它变为活跃状态status=true，而其他所有按钮变为非活跃状态status=false
        SLDbtnArea[i].status = false
      }
      SLDbtnArea[0].status = true
      getGoodsSource(callback3, SLDsource)
    }
    if (x >= SLDArea[1].startX
      && x <= SLDArea[1].endX
      && y >= SLDArea[1].startY
      && y <= SLDArea[1].endY) {
      page = 0
      flag2 = 0
      status = 1
      SLDArea[0].status = false
      SLDArea[1].status = true
      SLDArea[2].status = false
      for (let i in SLDbtnArea) {//点击该按钮的时候，它变为活跃状态status=true，而其他所有按钮变为非活跃状态status=false
        SLDbtnArea[i].status = false
      }
      SLDbtnArea[0].status = true
      getGoodsSource(callback3, SLDsource)
    }
    if (x >= SLDArea[2].startX
      && x <= SLDArea[2].endX
      && y >= SLDArea[2].startY
      && y <= SLDArea[2].endY) {
      if (styleOpen == true) styleOpen = false
      else styleOpen = true
      if (styleOpen == true) {
        page = 0
        flag2 = 0
        status = 3
        SLDArea[0].status = false
        SLDArea[1].status = false
        SLDArea[2].status = true
        for (let i in SLDbtnArea) {//点击该按钮的时候，它变为活跃状态status=true，而其他所有按钮变为非活跃状态status=false
          SLDbtnArea[i].status = false
        }
        SLDbtnArea[0].status = true
      }
      getGoodsSource(callback3, SLDsource)
    }
    //翻页控制
    if (x >= pageArea[0].startX
      && x <= pageArea[0].endX
      && y >= pageArea[0].startY
      && y <= pageArea[0].endY) {
      if (page == parseInt(GoodsSource.length / 9)) {

      } else {
        if (page < parseInt(GoodsSource.length / 9))//只有在当前页数小于实际页数的时候才能再往上+
          page++//点击翻页时页数+1
        console.log(page)
        //getFLDsource(callback1, url)//重绘
        reStart()
      }
    }
    if (x >= pageArea[1].startX
      && x <= pageArea[1].endX
      && y >= pageArea[1].startY
      && y <= pageArea[1].endY) {
      if (page == 0) {

      } else {
        if (page > 0)
          page--//点击翻页时页数-1
        console.log(page)
        reStart()
      }
    }
    //搜索
    if (x >= SearchButton[0].startX
      && x <= SearchButton[0].endX
      && y >= SearchButton[0].startY
      && y <= SearchButton[0].endY) {
      //清除目录控制状态 
      SLDArea[0].status = false
      SLDArea[1].status = false
      SLDArea[2].status = false
      for (let i in FLDbtnArea) {
        FLDbtnArea[i].status = false
      }
      GoodsSource = []
      wx.showKeyboard({
        defaultValue: '',
        maxLength: 8,
        multiple: false,
        confirmHold: true,
        confirmType: 'done',
        success: function () {
          wx.onKeyboardConfirm(((res) => {
            KeyWord = res.value
            context.fillStyle = '#fff'
            context.fillRect(76, 20, 220, 40)
            context.font = "26px Arial"
            context.fillStyle = '#696969'
            context.fillText(KeyWord, 90, 50)
            wx.hideKeyboard({})
            wx.showToast({
              title: '输入完成',
              icon: 'success',
              duration: 500
            })
          }))
        }
      })
      reStart()
    }
    if (x >= SearchButton[1].startX
      && x <= SearchButton[1].endX
      && y >= SearchButton[1].startY
      && y <= SearchButton[1].endY) {
      if (KeyWord == '') {
        //do nothing
      } else[
        wx.request({
          url: 'https://t6.9026.com/api/album/search_goods',
          data: {
            store_id: 1,
            keywords: KeyWord
          },
          method: 'GET',
          success: function (res) {
            try {
              let test = JSON.stringify(res.data)
              let tet = JSON.parse(test)
              GoodsSource.splice(0, GoodsSource.length)//每次调用重新填充数据的时候清空之前数据
              for (let i in tet.data.goods) {
                GoodsSource.push(tet.data.goods[i])
              }
            } catch (e) {
              wx.showToast({
                title: '请求异常',
                icon: 'none',
                duration: 800
              })
            }
            callback3(GoodsSource)//导出商品列表
          }
        })
      ]
    }
    //内容点击进入详情控制
    for (let con in ContentbtnArea) {
      if (x >= ContentbtnArea[con].startX
        && x <= ContentbtnArea[con].endX
        && y >= ContentbtnArea[con].startY
        && y <= ContentbtnArea[con].endY) {
        Detailstatus = true
        for (let x in ContentbtnArea) {
          ContentbtnArea[x].status = false
        }
        ContentbtnArea[con].status = true//用于判断是否进入详情
        con = parseInt(con)
        flag3 = (page * 9) + con
        Buttonstatus = false
        getGoodsDetail(callback4, GoodsSource)
        //reStart() //重绘
      }
    }

  }
  else {//在详情界面的时候
    if (attrFlag == false) {
      //  点击返回按钮返回原来界面
      if (x >= DetailbtnArea[0].startX
        && x <= DetailbtnArea[0].endX
        && y >= DetailbtnArea[0].startY
        && y <= DetailbtnArea[0].endY) {
        Detailstatus = false
        reStart() //重绘
      }
      //分享好友
      if (x >= DetailbtnArea[1].startX
        && x <= DetailbtnArea[1].endX
        && y >= DetailbtnArea[1].startY
        && y <= DetailbtnArea[1].endY) {
        wx.shareAppMessage({
          //title: '经销商id:' + agent_id,
          query: 'agent_id=' + agent_id
        })
      }
      //联系商家
      if (x >= DetailbtnArea[2].startX
        && x <= DetailbtnArea[2].endX
        && y >= DetailbtnArea[2].startY
        && y <= DetailbtnArea[2].endY) {
        if (isAgent == true) {
          wx.showKeyboard({
            defaultValue: '',
            maxLength: 11,
            multiple: false,
            confirmHold: true,
            confirmType: 'done',
            success: function () {
              let mobile = '10086'
              wx.onKeyboardConfirm(((res) => {
                mobile = res.value
                let turl = 'https://t6.9026.com/api/album/set-price'
                wx.request({
                  url: turl,
                  data: {
                    store_id: 1,
                    agent_id: agent_id,
                    type: 0,
                    mobile: mobile,
                    goods_id: GoodsDetail.id
                  },
                  method: 'GET',
                  success: function () {
                    wx.showToast({
                      title: '输入完成',
                      icon: 'success',
                      duration: 500
                    })
                    wx.hideKeyboard({})
                  }
                })
              }))
            }
          })
        }
        else {
          let tel = GoodsDetail.mobile
          wx.setClipboardData({
            data: tel,
            success: function () {
              if (tel == '') {
                wx.showToast({
                  title: '暂无商家联系电话',
                  icon: 'none',
                  duration: 800
                })
              } else {
                wx.showToast({
                  title: '电话' + tel + '已复制到剪贴板',
                  icon: 'none',
                  duration: 800
                })
              }
            }
          })
        }
      }
      //详情&购买
      if (x >= DetailbtnArea[3].startX
        && x <= DetailbtnArea[3].endX
        && y >= DetailbtnArea[3].startY
        && y <= DetailbtnArea[3].endY) {
        if (isAgent == true) {

          wx.showKeyboard({
            defaultValue: '',
            maxLength: 6,
            multiple: false,
            confirmHold: true,
            confirmType: 'done',
            success: function () {
              let price = 1000.0
              wx.onKeyboardConfirm(((res) => {
                price = res.value
                let turl = 'https://t6.9026.com/api/album/set-price'
                wx.request({
                  url: turl,
                  data: {
                    store_id: 1,
                    agent_id: agent_id,
                    type: 1,
                    price: price,
                    goods_id: GoodsDetail.id
                  },
                  method: 'GET',
                  success: function () {
                    wx.hideKeyboard({})
                    wx.showToast({
                      title: '输入完成',
                      icon: 'success',
                      duration: 500
                    })
                  }
                })
              }))
            }
          })
        }
        else {
          if (Buttonstatus == true) Buttonstatus = false
          else Buttonstatus = true
          let img = new wx.createImage()
          img.src = GoodsDetail.detail
          img.onload = function () {
            let ratio = img.width / img.height
            context.drawImage(img, screenWidth - (screenHeight - 80) * ratio, 60, (screenHeight - 80) * 2 * ratio, (screenHeight - 80) * 2)
          }
        }
      }
      //尺寸&安装
      if (x >= DetailbtnArea[4].startX
        && x <= DetailbtnArea[4].endX
        && y >= DetailbtnArea[4].startY
        && y <= DetailbtnArea[4].endY) {
        attrFlag = true
        Buttonstatus = false
        let img = new wx.createImage()
        img.src = GoodsDetail.upload_img
        img.onload = function () {
          let ratio = img.width / img.height
          context.drawImage(img, (screenWidth - (screenHeight - 100) * ratio), 120, (screenHeight - 100) * 2 * ratio, (screenHeight - 100) * 2)
          context.fillStyle = '#F5F5F5'
          context.fillRect((screenWidth - (screenHeight - 100) * ratio), 60, (screenHeight - 100) * 2 * ratio, 60)
          context.fillStyle = '#FFA500'
          context.fillRect((screenWidth - (screenHeight - 100) * ratio), 118, (screenHeight - 100) * ratio,2 )
          context.fillStyle = '#696969'
          context.font = '30px Arial'
          context.fillText('安装图', screenWidth - 280, 100)
          context.fillText('尺寸图', screenWidth + 190, 100)
          let closeImg = wx.createImage()
          closeImg.src = 'images/close.png'
          closeImg.onload = function(){
            context.drawImage(closeImg,screenWidth + (screenHeight - 100) * ratio - 60,60,60,60)
          }
        }
      }
      //上一张
      if (x >= DetailbtnArea[5].startX
        && x <= DetailbtnArea[5].endX
        && y >= DetailbtnArea[5].startY
        && y <= DetailbtnArea[5].endY) {
        Buttonstatus = false
        if (flag3 <= 0) {
          wx.showToast({
            title: '已经是第一个了',
            icon: 'none',
            duration: 800
          })
          flag3 = 0
          reStart()
        }
        if (flag3 > 0) {
          flag3 = flag3 - 1
          console.log('flag3:' + flag3)
          getGoodsDetail(callback4, GoodsSource)
        }
      }
      //下一张
      if (x >= DetailbtnArea[6].startX
        && x <= DetailbtnArea[6].endX
        && y >= DetailbtnArea[6].startY
        && y <= DetailbtnArea[6].endY) {
        Buttonstatus = false
        if (flag3 == GoodsSource.length - 1) {
          wx.showToast({
            title: '已经是最后一个了',
            icon: 'none',
            duration: 800
          })
        }
        if (flag3 < GoodsSource.length - 1) {
          flag3 = flag3 + 1
          console.log('flag3:' + flag3)
          getGoodsDetail(callback4, GoodsSource)
        }
      }
      //隐藏或显示按钮
      if (x >= 75
        && x <= screenWidth - 40
        && y >= 0
        && y <= screenHeight - 40) {
        if (Buttonstatus == true) {
          Buttonstatus = false
          reStart()
        }
        else {
          Buttonstatus = true
          reStart()
        }
      }
    } else {//在尺寸和安装图片转化界面
      if (x >= attrArea[0].startX
        && x <= attrArea[0].endX
        && y >= attrArea[0].startY
        && y <= attrArea[0].endY) {
        attrFlag = true
        Buttonstatus = false
        let img = new wx.createImage()
        img.src = GoodsDetail.upload_img
        img.onload = function () {
          let ratio = img.width / img.height
          context.drawImage(img, (screenWidth - (screenHeight - 100) * ratio), 120, (screenHeight - 100) * 2 * ratio, (screenHeight - 100) * 2)
          context.fillStyle = '#F5F5F5'
          context.fillRect((screenWidth - (screenHeight - 100) * ratio), 60, (screenHeight - 100) * 2 * ratio, 60)
          context.fillStyle = '#FFA500'
          context.fillRect((screenWidth - (screenHeight - 100) * ratio), 118, (screenHeight - 100) * ratio, 2)
          context.fillStyle = '#696969'
          context.font = '30px Arial'
          context.fillText('安装图', screenWidth - 280, 100)
          context.fillText('尺寸图', screenWidth + 190, 100)
          let closeImg = wx.createImage()
          closeImg.src = 'images/close.png'
          closeImg.onload = function () {
            context.drawImage(closeImg, screenWidth + (screenHeight - 100) * ratio - 60, 60, 60, 60)
          }
        }
      }
      if (x >= attrArea[1].startX
        && x <= attrArea[1].endX
        && y >= attrArea[1].startY
        && y <= attrArea[1].endY) {
        attrFlag = true
        Buttonstatus = false
        let img = new wx.createImage()
        img.src = GoodsDetail.attr
        img.onload = function () {
          let ratio = img.width / img.height
          context.drawImage(img, (screenWidth - (screenHeight - 100) * ratio), 120, (screenHeight - 100) * 2 * ratio, (screenHeight - 100) * 2)
          context.fillStyle = '#F5F5F5'
          context.fillRect((screenWidth - (screenHeight - 100) * ratio), 60, (screenHeight - 100) * 2 * ratio, 60)
          context.fillStyle = '#FFA500'
          context.fillRect(screenWidth, 118, (screenHeight - 100) * ratio, 2)
          context.fillStyle = '#696969'
          context.font = '30px Arial'
          context.fillText('安装图', screenWidth - 280, 100)
          context.fillText('尺寸图', screenWidth + 190, 100)
          let closeImg = wx.createImage()
          closeImg.src = 'images/close.png'
          closeImg.onload = function () {
            context.drawImage(closeImg, screenWidth + (screenHeight - 100) * ratio - 60, 60, 60, 60)
          }
        }
      }
      //隐藏安装尺寸图片
      if (x >= attrArea[2].startX
        && x <= attrArea[2].endX
        && y >= attrArea[2].startY
        && y <= attrArea[2].endY) {
        attrFlag = false
        Buttonstatus = false
        reStart()
      }
    }
  }

}))
//滑动响应函数
wx.onTouchEnd(((e) => {
  var endX = e.changedTouches[0].clientX
  var endY = e.changedTouches[0].clientY
  if (Detailstatus == false) {

  }
  if (Detailstatus == true) {//在详情界面，左右滑动，查看商品
    if (attrFlag == false) {
      if (endX - startx > 0) {//向右滑动
        Buttonstatus = false
        if (flag3 <= 0) {
          wx.showToast({
            title: '已经是第一个了',
            icon: 'none',
            duration: 800
          })
          flag3 = 0
          reStart()
        }
        if (flag3 > 0) {
          flag3 = flag3 - 1
          console.log('flag3:' + flag3)
          getGoodsDetail(callback4, GoodsSource)
        }
      }
      if (endX - startx < 0) {//向左滑动
        Buttonstatus = false
        if (flag3 == GoodsSource.length - 1) {
          wx.showToast({
            title: '已经是最后一个了',
            icon: 'none',
            duration: 800
          })
        }
        if (flag3 < GoodsSource.length - 1) {
          flag3 = flag3 + 1
          console.log('flag3:' + flag3)
          getGoodsDetail(callback4, GoodsSource)
        }
      }
    }
  }
}))
//清除之前绘制内容
function reset() {
  context.clearRect(0, 0, screenWidth * 2, screenHeight * 2)
}
//获取顶级目录列表
function getFLDsource(callback1, url) {
  try {
    wx.request({
      url: url,  //这里''里面填写你的服务器API接口的路径    
      data: {
      },  //这里是可以填写服务器需要的参数    
      method: 'GET', // 声明GET请求    
      // header: {}, // 设置请求的 header，GET请求可以不填    
      success: function (res) {
        if (res.statusCode == 200) {
          let test = JSON.stringify(res.data)
          let tet = JSON.parse(test)
          FLDsource.splice(0, FLDsource.length)
          for (let i in tet.data.cats) {
            FLDsource.push(tet.data.cats[i])
          }
          callback1(FLDsource)//导出顶级目录列表
        }
        //console.log(res.statusCode)
      }
    });
  } catch (e) {
    wx.showToast({
      title: '加载异常',
      icon: 'none',
      duration: 500
    })
  }

}
//在回调函数中通过顶级目录个数获得它的按钮区域
function callback1(res) {
  FLDbtnArea.splice(0, FLDbtnArea.length)//每次调用重新填充数据的时候清空之前数据
  for (let i = 0; i < res.length; i++) {//通过顶级目录个数获得它的按钮区域
    let s = false
    if (i == flag1) s = true
    let FLDobj = new Object()
    FLDobj.startX = screenWidth - 50
    FLDobj.startY = 50 * (i + 1)
    FLDobj.endX = screenWidth
    FLDobj.endY = 50 * (i + 2)
    FLDobj.status = s
    FLDbtnArea.push(FLDobj)
  }
  //console.log(FLDsource)
  getSLDsource(callback2, FLDsource)//获取二级目录信息
}
//根据获取第一个请求函数得到的顶级目录信息来获取二级目录信息
function getSLDsource(callback2, FLDsource) {
  //  通过flag1来判断现在处于哪一个顶级目录，然后利用flag1传参数获取该顶级目录下的二级目录信息
  let u = 'https://t6.9026.com/api/album/style?store_id=1'
  //console.log(u)
  try {
    wx.request({
      url: u,
      data: {
      },
      method: 'GET',
      success: function (res) {
        if (res.statusCode == 200) {
          let test = JSON.stringify(res.data)
          let tet = JSON.parse(test)
          SLDsource.splice(0, SLDsource.length)//每次调用重新填充数据的时候清空之前数据
          for (let i in tet.data.style) {
            SLDsource.push(tet.data.style[i])
          }
          callback2(SLDsource)//导出二级目录列表
        }
        //  console.log(res.statusCode)
      }
    })
  } catch (e) {
    wx.showToast({
      title: '加载异常',
      icon: 'none',
      duration: 500
    })
  }
}
//通过二级目录列表的长度来得到它的按钮区域列表
function callback2(res) {
  SLDbtnArea.splice(0, SLDbtnArea.length)//每次调用重新填充数据的时候清空之前数据
  for (let i = 0; i < res.length; i++) {
    let s = false
    if (i == flag2) s = true
    let SLDobj = new Object()
    if (isiPhoneX) {
      SLDobj.startX = 35
    } else {
      SLDobj.startX = 0
    }
    SLDobj.startY = 25 * (i + 4) + 35
    if (isiPhoneX) {
      SLDobj.endX = 70
    } else {
      SLDobj.endX = 40
    }
    SLDobj.endY = 25 * (i + 5) + 35
    SLDobj.status = s
    SLDbtnArea.push(SLDobj)
  }
  //console.log(SLDsource)
  // reStart()
  getGoodsSource(callback3, SLDsource)
}
function getGoodsSource(callback3, SLDsource) {
  cat_id = FLDsource[flag1].id
  if (SLDsource) {
    style = SLDsource[flag2].id
  }
  let u = 'https://t6.9026.com/api/album/goods' + '?store_id=1&cat_id=' + cat_id + '&status=' + status + '&style=' + style
  wx.request({
    url: u,
    data: {
    },
    method: 'GET',
    success: function (res) {
      try {
        let test = JSON.stringify(res.data)
        let tet = JSON.parse(test)
        FactoryName = tet.data.name
        GoodsSource.splice(0, GoodsSource.length)//每次调用重新填充数据的时候清空之前数据
        for (let i in tet.data.goods) {
          GoodsSource.push(tet.data.goods[i])
        }
      } catch (e) {
        wx.showToast({
          title: '请求异常',
          icon: 'none',
          duration: 800
        })
      }
      callback3(GoodsSource)//导出商品列表
      //console.log(res.statusCode)
    }
  })

}
function callback3(res) {
  // console.log(GoodsSource)
  reStart()
}
function getGoodsDetail(callback4, GoodsSource) {
  //如果所点击的区域没有商品展示，那么不进入详情界面
  let ur = 'https://t6.9026.com/api/album/goods-detail?store_id=1&agent_id=' + agent_id + '&goods_id='
  try {
    ur = ur + GoodsSource[flag3].id
  } catch (e) {
    console.log(e.message)
    Detailstatus = false
    // reStart()
  }
  wx.request({
    url: ur,
    data: {
    },
    method: 'GET',
    success: function (res) {
      try {
        GoodsDetail = {}
        let test = JSON.stringify(res.data)
        let tet = JSON.parse(test)
        GoodsDetail = tet.data.goods
      } catch (e) {
        Detailstatus = false
        wx.showToast({
          title: '暂无商品详情',
          icon: 'none',
          duration: 800
        })
      }
      callback4(GoodsDetail)//导出商品列表
    }
  })
}
function callback4(res) {
  if (GoodsDetail == null) {
    // wx.hideLoading()
  } else {
    wx.showLoading({
      title: 'loading',
    })
    //console.log(GoodsDetail)
  }
  if (Detailstatus == true)//如果没获取到详情，说明所点击区域没有元素，不进行重绘
    reStart()
}

function UserLogin() {
  wx.login({
    success: function (res) {
      let code = res.code
      console.log(code)
      wx.getUserInfo({
        success: function (res) {
          let encrypted_data = res.encryptedData
          let iv = res.iv
          let tx = res.userInfo.avatarUrl
          let nn = res.userInfo.nickName
          wx.request({
            url: 'https://t6.9026.com/api/album/xyx_login',
            method: 'POST',
            data: {
              code: code,
              avatar: tx,
              nickName: nn,
              iv: iv,
              store_id: 1
            },
            success: function (res) {
              let is_agent = res.data.data.d.data.is_agent
              if (is_agent == 1) {
                isAgent = true
                agent_id = res.data.data.d.data.agent_id
              }
              else {
                isAgent = false
                var test = wx.getLaunchOptionsSync()
                console.log(test)
                agent_id = test.query.agent_id
                if (agent_id == undefined)
                  agent_id = 0
                console.log(agent_id)
              }
            }
          })
        }
      })
    }
  })
}
function sleep(time) {
  return new Promise((resolve) => setTimeout(resolve, time));
}
/*
主函数
*/
export default class Main {
  constructor() {
    UserLogin()
    getFLDsource(callback1, url)
  }
}