
/*
绘制二级目录列表
*/
//获取手机屏幕大小信息
var sw = 0
var sh = 0
//是否为iPhoneX
let isiPhoneX = false
wx.getSystemInfo({
  success: function (res) {
    sw = res.screenWidth
    sh = res.screenHeight
    let mobileType = res.model
    if (mobileType == 'iPhone X') isiPhoneX = true
    else isiPhoneX = false
  }
})
const screenWidth = sw
const screenHeight = sh

//绘制子目录列表
export default class SLD {
  drawSLD(context, status, index, text) {
    index = index + 4
    if(isiPhoneX){
      //未被选中时
      if (status == false) {
        //绘制文字，选中和未选中状态下文字颜色不一样
        context.fillStyle = '#696969'
        context.font = "20px Arial"
        //文字总是保持居中，只考虑了2个和3个字
        if (text.length == 3) {
          context.fillText(text, 70+2 * 2, (index * 25 + 50) * 2)
        }
        if (text.length == 2) {
          context.fillText(text, 70+8 * 2, (index * 25 + 50) * 2)
        }
      }
      else {//当被选中时，突出显示
        context.fillStyle = '#dcdcdc'
        context.fillRect(70, (index * 25 + 35) * 2, 40 * 2, 50, )

        ///绘制文字，选中和未选中状态下文字颜色不一样
        context.fillStyle = '#FFA500'
        context.font = "20px Arial"
        //文字总是保持居中，只考虑了2个和3个字
        if (text.length == 3) {
          context.fillText(text, 70+2 * 2, (index * 25 + 50) * 2)
        }
        if (text.length == 2) {
          context.fillText(text, 70+8 * 2, (index * 25 + 50) * 2)
        }
      }
    }else{
      //未被选中时
      if (status == false) {

        //绘制文字，选中和未选中状态下文字颜色不一样
        context.fillStyle = '#696969'
        context.font = "20px Arial"
        //文字总是保持居中，只考虑了2个和3个字
        if (text.length == 3) {
          context.fillText(text, 2 * 2, (index * 25 +50) * 2)
        }
        if (text.length == 2) {
          context.fillText(text, 8 * 2, (index * 25 +50) * 2)
        }
      }
      else {//当被选中时，突出显示
        context.fillStyle = '#dcdcdc'
        context.fillRect(0, (index * 25 + 35) * 2, 40 * 2, 50,)
        
        ///绘制文字，选中和未选中状态下文字颜色不一样
        context.fillStyle = '#FFA500'
        context.font = "20px Arial"
        //文字总是保持居中，只考虑了2个和3个字
        if (text.length == 3) {
          context.fillText(text, 2 * 2, (index * 25 + 50) * 2)
        }
        if (text.length == 2) {
          context.fillText(text, 8 * 2, (index * 25 + 50) * 2)
        }
      }
    }
    
  }
}
