/*
主体内容绘制
*/

//获取手机屏幕大小信息
var sw = 0
var sh = 0
//是否为iPhoneX
let isiPhoneX = false
wx.getSystemInfo({
  success: function (res) {
    sw = res.screenWidth
    sh = res.screenHeight
    let mobileType = res.model
    if (mobileType == 'iPhone X') isiPhoneX = true
    else isiPhoneX = false
  }
})
const screenWidth = sw
const screenHeight = sh
var imgx = 0
var imgy = 0
if (isiPhoneX) {
  imgx = (screenWidth - 240 - 35) / 3
  imgy = (screenHeight - 118) / 3
} else {
  imgx = (screenWidth - 180) / 3
  imgy = (screenHeight - 118) / 3
}
const imgX = imgx
const imgY = imgy
//每个页面放九个元素，每个元素依据它的下标来确定放置的位置
export default class Content {
  drawContent(context, image, index, text) {
    context.fillStyle = '#000'
    context.font = "24px Arial"
    if (isiPhoneX) {
      if (index % 9 == 0) {
        //先绘制示例图
        image.onload = function () {
          context.drawImage(image, (40 + 17+ 10 + 40) * 2 + 70, 42 * 2, imgX * 2, imgY * 2)
        }
        //绘制描述文字
        context.fillText(text, (40 + 40 + 17 + 10 + 15) * 2 + 70, (imgY + 2 + 15 + 40) * 2)
      }
      if (index % 9 == 1) {
        image.onload = function () {
          context.drawImage(image, (40 + 40+ 17 + 10 + imgX + 10) * 2 + 70, 42 * 2, imgX * 2, imgY * 2)
        }
        context.fillText(text, (40 + 40 + 17 + 10 + imgX + 10 + 15) * 2 + 70, (imgY + 2 + 15 + 40) * 2)
      }
      if (index % 9 == 2) {
        image.onload = function () {
          context.drawImage(image, (40 + 40 + 17 + 10 + imgX + 10 + imgX + 10) * 2 + 70, 42 * 2, imgX * 2, imgY * 2)
        }
        context.fillText(text, (40 + 40 + 17 + 10 + imgX + 10 + imgX + 10 + 15) * 2 + 70, (imgY + 2 + 15 + 40) * 2)
      }
      if (index % 9 == 3) {
        image.onload = function () {
          context.drawImage(image, (40 + 40 + 17 + 10) * 2 + 70, (2 + imgY + 15 + 10 + 40) * 2, imgX * 2, imgY * 2)
        }
        context.fillText(text, (40 + 40 + 17 + 10 + 15) * 2 + 70, (imgY + 2 + 15 + imgY + 10 + 15 + 40) * 2)
      }
      if (index % 9 == 4) {
        image.onload = function () {
          context.drawImage(image, (40 + 40 + 17 + 10 + imgX + 10) * 2 + 70, (2 + imgY + 15 + 10 + 40) * 2, imgX * 2, imgY * 2)
        }
        context.fillText(text, (40 + 40 + 17 + 10 + imgX + 10 + 15) * 2 + 70, (imgY + 2 + 15 + imgY + 10 + 15 + 40) * 2)

      }
      if (index % 9 == 5) {
        image.onload = function () {
          context.drawImage(image, (40 + 40 + 17 + 10 + imgX + 10 + imgX + 10) * 2 + 70, (2 + imgY + 15 + 10 + 40) * 2, imgX * 2, imgY * 2)
        }
        context.fillText(text, (40 + 40 + 17 + 10 + imgX + 10 + imgX + 10 + 15) * 2 + 70, (imgY + 2 + 15 + imgY + 10 + 15 + 40) * 2)
      }
      if (index % 9 == 6) {
        image.onload = function () {
          context.drawImage(image, (40 + 40 + 17 + 10) * 2 + 70, (2 + imgY + 15 + 10 + imgY + 15 + 10 + 40) * 2, imgX * 2, imgY * 2)
        }
        context.fillText(text, (40 + 40 + 10 + 17 + 15) * 2 + 70, (imgY + 2 + 15 + imgY + 10 + 15 + imgY + 10 + 15 + 40) * 2)
      }
      if (index % 9 == 7) {
        image.onload = function () {
          context.drawImage(image, (40 + 40 + 17 + 10 + imgX + 10) * 2 + 70, (2 + imgY + 15 + 10 + imgY + 15 + 10 + 40) * 2, imgX * 2, imgY * 2)
        }
        context.fillText(text, (40 + 40 + 17 + 10 + imgX + 10 + 15) * 2 + 70, (imgY + 2 + 15 + imgY + 10 + 15 + imgY + 10 + 15 + 40) * 2)
      }
      if (index % 9 == 8) {
        image.onload = function () {
          context.drawImage(image, (40 + 40 + 17 + 10 + imgX + 10 + imgX + 10) * 2 + 70, (2 + imgY + 15 + 10 + imgY + 15 + 10 + 40) * 2, imgX * 2, imgY * 2)
        }
        context.fillText(text, (40 + 40 + 17 + 10 + imgX + 10 + imgX + 10 + 15) * 2 + 70, (imgY + 2 + 15 + imgY + 10 + 15 + imgY + 15 + 10 + 40) * 2)
      }
    } else {
      if (index % 9 == 0) {
        //先绘制示例图
        image.onload = function () {
          context.drawImage(image, (40 + 10+17) * 2, 42 * 2, imgX * 2, imgY * 2)
        }
        //绘制描述文字
        context.fillText(text, (40 + 10 + 15) * 2, (imgY + 2 +40 + 15) * 2)
      }
      if (index % 9 == 1) {
        image.onload = function () {
          context.drawImage(image, (40 + 10 + imgX + 17+ 10) * 2, 42 * 2, imgX * 2, imgY * 2)
        }
        context.fillText(text, (40 + 10 + imgX + 10 + 15) * 2, (imgY + 2 + 40+ 15) * 2)
      }
      if (index % 9 == 2) {
        image.onload = function () {
          context.drawImage(image, (40 + 10 + 17 + imgX + 10 + imgX + 10) * 2, 42 * 2, imgX * 2, imgY * 2)
        }
        context.fillText(text, (40 + 10 + imgX + 10 + imgX + 10 + 15) * 2, (imgY + 2 + 40 + 15) * 2)
      }
      if (index % 9 == 3) {
        image.onload = function () {
          context.drawImage(image, (40 + 17 + 10) * 2, (2 + imgY + 15 + 10 + 40) * 2, imgX * 2, imgY * 2)
        }
        context.fillText(text, (40 + 10 + 15) * 2, (imgY + 2 + 15 + imgY + 10 + 15 + 40) * 2)
      }
      if (index % 9 == 4) {
        image.onload = function () {
          context.drawImage(image, (40 + 17 + 10 + imgX + 10) * 2, (2 + imgY + 15 + 10 + 40) * 2, imgX * 2, imgY * 2)
        }
        context.fillText(text, (40 + 10 + imgX + 10 + 15) * 2, (imgY + 2 + 15 + imgY + 10 + 15 + 40) * 2)

      }
      if (index % 9 == 5) {
        image.onload = function () {
          context.drawImage(image, (40 + 17 + 10 + imgX + 10 + imgX + 10) * 2, (2 + imgY + 15 + 10 + 40) * 2, imgX * 2, imgY * 2)
        }
        context.fillText(text, (40 + 10 + imgX + 10 + imgX + 10 + 15) * 2, (imgY + 2 + 15 + imgY + 10 + 15 + 40) * 2)
      }
      if (index % 9 == 6) {
        image.onload = function () {
          context.drawImage(image, (40 + 17 + 10) * 2, (2 + imgY + 15 + 10 + imgY + 15 + 10 + 40) * 2, imgX * 2, imgY * 2)
        }
        context.fillText(text, (40 + 10 + 15) * 2, (imgY + 2 + 15 + imgY + 10 + 15 + imgY + 10 + 15 + 40) * 2)
      }
      if (index % 9 == 7) {
        image.onload = function () {
          context.drawImage(image, (40 + 17 + 10 + imgX + 10) * 2, (2 + imgY + 15 + 10 + imgY + 15 + 10 + 40) * 2, imgX * 2, imgY * 2)
        }
        context.fillText(text, (40 + 10 + imgX + 10 + 15) * 2, (imgY + 2 + 15 + imgY + 10 + 15 + imgY + 10 + 15 + 40) * 2)
      }
      if (index % 9 == 8) {
        image.onload = function () {
          context.drawImage(image, (40 + 17 + 10 + imgX + 10 + imgX + 10) * 2, (2 + imgY + 15 + 10 + imgY + 15 + 10 + 40) * 2, imgX * 2, imgY * 2)
        }
        context.fillText(text, (40 + 10 + imgX + 10 + imgX + 10 + 15) * 2, (imgY + 2 + 15 + imgY + 10 + 15 + imgY + 15 + 10 + 40) * 2)
      }
    }

  }
}
