// index/info/info.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    isWenke: true,
    batchs: [],
    batchsIndex: 0,
    provinces:[],
    provincesIndex:0,
    infoDown: true,

    username: '',
    cnumber: '',
    class: '',
    grade: 0,
    batch: '',
    province: '',
    code: '',
    errMsg:'',
    phone:'10086',
    phonein:0
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    var that = this
    wx.request({
      url: 'https://t10.9026.com/api/home/getbasedata',  //这里''里面填写你的服务器API接口的路径    
      data: {
      },  //这里是可以填写服务器需要的参数    
      method: 'GET', // 声明GET请求    
      // header: {}, // 设置请求的 header，GET请求可以不填    
      complete: function (res) {
        let test = JSON.stringify(res.data)
        let tet = JSON.parse(test)
        that.setData({
          batchs: tet.data.batchs,
          provinces: tet.data.provinces,
          batch: tet.data.batchs[0],
          proince:tet.data.provinces[0]
        })
      }
    });
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  codeInput: function(e){
    this.setData({
      code: e.detail.value
    })
  },
  cnumberInput: function(e){
    this.setData({
      cnumber: e.detail.value
    })
  },
  usernameInput: function(e){
    this.setData({
      username: e.detail.value
    })
  },
  gradeInput: function(e){
    this.setData({
      grade: parseInt(e.detail.value)
    })
  },
  phoneInput: function(e){
    this.setData({
      phonein: e.detail.value
    })
  },
  showTopTips: function () {
    wx.navigateTo({
      url: '../result/result'
    })
    var that = this
    if(that.data.cnumber == ''){
      that.setData({
        infoDown: false,
        errMsg:'考号不能为空'
      })
    }
    if (that.data.username == '') {
      that.setData({
        infoDown: false,
        errMsg: '姓名不能为空'
      })
    }
    if (that.data.grade == 0) {
      that.setData({
        infoDown: false,
        errMsg: '成绩不能为空'
      })
    }
    if (that.data.phonein != that.data.phone){
      that.setData({
        infoDown: false,
        errMsg: '手机号错误'
      })
    }
    if (that.data.infoDown == false) {
      this.setData({
        showTopTips: true
      });
      setTimeout(function () {
        that.setData({
          showTopTips: false
        });
      }, 3000);
      that.setData({
        infoDown: true
      })
    } else {
      console.log(that.data)
      var app = getApp()
      app.userinfo.code = that.data.code
      app.userinfo.class = that.data.class
      app.userinfo.username = that.data.username
      app.userinfo.cnumber = that.data.cnumber
      app.userinfo.grade = that.data.grade
      app.userinfo.phonenumber = that.data.phone
      app.userinfo.batch = that.data.batch
      app.userinfo.province = that.data.province

      console.log(getApp().userinfo.code )
      console.log(getApp().userinfo.class)
      console.log(getApp().userinfo.username)
      console.log(getApp().userinfo.cnumber)
      console.log(getApp().userinfo.grade)
      console.log(getApp().userinfo.phonenumber)
      console.log(getApp().userinfo.batch)
      console.log(getApp().userinfo.province)
      wx.navigateTo({
        url: '../result/result'
      })
      
    }
  },
  bindBatchsChange: function (e) {
    var that = this
    console.log('picker batchs 发生选择改变，携带值为', e.detail.value);

    this.setData({
      batchsIndex: parseInt(e.detail.value),
    })
    this.setData({
      batch: that.data.batchs[parseInt(e.detail.value)]
    })
  },
  bindProvincesChange: function (e) {
    var that = this
    console.log('picker provinces 发生选择改变，携带值为', e.detail.value);

    this.setData({
      provincesIndex: parseInt(e.detail.value),
    })
    this.setData({
      province: that.data.provinces[parseInt(e.detail.value)]
    })
  },
  getPhoneNumber:function(e){
    console.log(e.detail.errMsg)
    console.log(e.detail.iv)
    console.log(e.detail.encryptedData) 
  },
  wenke: function () {
    this.setData({
      isWenke:true,
      class:'文科'
    })
  },
  like: function () {
    this.setData({
      isWenke: false,
      class:'理科'
    })
  }
})