// index/result/result.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    userid: 0,
    username: '',
    cnumber: '',
    class: '',
    grade: 0,
    batch: '',
    province: '',
    code: '',
    mobile: 0,
    rank: 0,
    college_count: 0,
    price:'',
    timeStamp:'',
    nonceStr:'',
    package:'',
    signType:'',
    paySign:'',
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    var that = this
    that.setData({
      userid: getApp().userinfo.userid,
      username: getApp().userinfo.username,
      cnumber: getApp().userinfo.cnumber,
      class: getApp().userinfo.class,
      grade: getApp().userinfo.grade,
      batch: getApp().userinfo.batch,
      province: getApp().userinfo.province,
      code: getApp().userinfo.code,
      mobile: parseInt(getApp().userinfo.phonenumber),
    })
    console.log('result:')
    this.getFreeInfo()
    console.log(that.data)
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  getFreeInfo: function () {
    var that = this
    wx.request({
      url: 'https://t10.9026.com/api/home/getqueried',
      data: {
        userid: that.data.userid,
        username: that.data.username,
        cnumber: that.data.cnumber,
        class: that.data.class,
        grade: that.data.grade,
        batch: that.data.batch,
        province: that.data.province,
        code: that.data.code,
        mobile: that.data.mobile,
      },
      method: 'POST',
      success: function (res) {
        console.log(res.data)
        that.setData({
          college_count:res.data.data.college_count,
          rank:res.data.data.rank
        })
      }
    })
  },
  getRechargeableInfo: function () {
    var that = this
    wx.request({
      url: 'https://t10.9026.com/api/home/getpaidmajors',
      data: {
        userid: that.data.userid,
        username: that.data.username,
        batch: that.data.batch,
        province: that.data.province,
        class: that.data.class
      },
      method: 'POST',
      success: function (res) {
        console.log(res.data)
        //this.showRechargeableInfo()
        if(res.data.data.price){
          that.setData({
            price: res.data.data.price
          })
          wx.request({
            url: 'https://t10.9026.com/api/home/pay',
            data:{
              userid:that.data.userid,
              price:that.data.price
            },
            method:'POST',
            success:function(res){
              console.log(res.data.data.json)
              var r = JSON.parse(res.data.data.json)
              console.log(r)
              that.setData({
                timeStamp: r.timeStamp,
                nonceStr: r.nonceStr,
                package: r.package,
                signType: r.signType,
                paySign: r.paySign,
              })
              wx.requestPayment({
                timeStamp: that.data.timeStamp,
                nonceStr: that.data.nonceStr,
                package: that.data.package,
                signType: that.data.signType,
                paySign: that.data.paySign,
                success:function(res){//支付成功之后再获取付费信息
                  console.log(res.errMsg)

                }
              })
            }
          })
        }else{
          console.log('已付费')
        }
      }
    })
  },
  showRechargeableInfo: function () {

  }
}) 