## 存在的问题

//1.小游戏横屏显示问题

//2.上传电话和价格暂时没写

//3.在详情界面的滑动效果不是很理想

//4.分享的时候带参数agent_id

5.打电话

6.第一次加载商品详情的时候很慢

## 问题解决和程序优化说明

—添加了电话、名片(名片部分目前已删除)

—如果是经销商的话详情界面上传电话和价格，但是没能上传成功

—判断是否是经销商的接口还没有

—目前程序默认是经销商

—横屏问题解决：重新设置canvas的宽高 5/28

—下一页按钮禁用优化 5/29

—进入详情的回调函数优化 

— 把详情界面按钮换成图片 5/31

— 清晰度调整（canvas放大两倍，所有绘制参数放大两倍）

— 详情界面添加点击查看上一个或下一个的按钮

— 针对iphnex做了优化

—  登录接口通

— 完成上传电话和价格

— loading 优化

— 上一页下一页 6/2

— 安装尺寸

— iPhoneX优化

— 优化loading

— 详情界面的UI修改 6/5

— 继续针对iPhoneX和loading进行优化

— agent_id换成了用户输入的方式

— 商品列表UI的修改6/6

—  iPhoneX优化

— 商品列表UI的修改6/7

— 添加搜索功能

— loading BUG修复

— 更新厂家名字 6/8

— 安装尺寸界面更改

— 一级目录名字不显示bug修复

## 目录源码介绍

```javascript
./js
|——draw
|  |——base.js. 						//绘制两边的目录栏背景和下一页按钮
|  |——FirstLevelDirectory.js		//绘制顶级目录
|  |——SecondLevelDirectory.js  	    //绘制子目录
|  |——content.js					//绘制商品列表
|  |——details.js					//绘制商品详情
|——lib
|  |——symbol.js                     // ES6 Symbol简易兼容
|  |——weapp-adapter.js              // 小游戏适配器
|——main.js							//绘制入口
```

